#include <stdio.h>
#include <stdlib.h> // atoi() atof()
#include <math.h>   // sin() !!! kompilovat s -lglut ale neviem preco !!!

#define N 9
#define X 3.14159

double fcia_1(int n, double x);
double fcia_2(int n, double x); 
void zadanie(void);

int main(int argc, char **argv)
{
  int n=9;
  double x=3.14159;
 
  zadanie();

  /* ak boli zadane parametre n a x */
  if (argc>2) {
    n=atoi(argv[1]);
    x=atof(argv[2]);
  }

  /* osetrenie divnych parametrov */
  if ((n<1)||(n>1000)) n=N;
  if (!x) x=X;

  printf("Pre n=%i a x=%.5f ma postupnost sin(x)+sin^2(x)+...+sin^n(x)\
 hodnotu %.5f\n", n, x, fcia_1(n, x));
  printf("Pre n=%i a x=%.5f ma postupnost sin(x)+sin(x^2)+...+sin(x^n)\
 hodnoru %.5f\n\n", n, x, fcia_2(n, x));

  return(0);
}


/* funkcia vyrata sin(x)+sin^2(x)+...+sin^n(x) */
double fcia_1(int n, double x)
{
  register double result=0.0;
  register double res=0.0;
  register i, j;
 
  i=n;
  while (i) {
    j=i;
    res=sin(x);
    while (j-1) {
      res*=sin(x);
      j--;
    }
    result+=res;
    i--;
  }  
         
  return(result);
}


/* funkcia vyrata sin(x)+sin(x^2)+...+sin(x^n) */	
double fcia_2(int n, double x)
{
  register double result=0.0;
  register double res=0.0;
  register i, j;

  i=n;
  while (i) {
    j=i;
    res=x;
    while (j-1) {
      res+=x;
      j--;
    }
    result*=sin(res);
    i--;
  }  
        
  return(result);
}


/* funkcia vypise text ulohy */
void zadanie(void)
{
  fputs("\nUloha 03: Vypocet sin(x)+sin^2(x)+...+sin^n(x) a sin(x)+sin(x^2)+...+sin(x^n)\n\
          pre n (prirodzene cislo) 9\n\
          pre x (double cislo - rad) 3.14\n\
          Hodnoty n (tak do 1000) a x mozno zadat ako parametre\n\
Priklad : ./03 77 7.77\n\n", stdout);

  return;
}
