#include <stdio.h>
#include <string.h>
#include <stdlib.h> // atoi()

#define KELO 1 // kolko vyskytov znaku chcem
#define MAX 1024

char *file_name_in="f";
char *file_name_out="g";

void zadanie(char *meno_programu);

int main(int argc, char **argv)
{
  FILE *file_in, *file_out;
  int pocetnost[MAX][2];  
  char cislo_str[32];
  int cislo, bulo, kelo, i;
	  
  zadanie(argv[0]);
  kelo=KELO;

  /* ak boli zadane aj nazvy suborov a pocetnost kelo */
  if (argc>1) file_name_in=argv[1];
  if (argc>2) file_name_out=argv[2];
  if (argc>3) if ((kelo=atoi(argv[3]))<1) kelo=KELO;

  /* osetrenie existencie in suboru pre citanie */
  if (!(file_in=fopen(file_name_in, "r"))) {
    printf("Chyba pri citani suboru %s\n", file_name_in);
    return(-1);
  }

  /* osetrenie realnosti zapisu do suboru out */
  if (!(file_out=fopen(file_name_out, "w"))) {
    printf("Chyba pri zapise do suboru %s\n", file_name_out);
    return(-1);
  }

  for (i=0; i<MAX; i++) pocetnost[i][0]=pocetnost[i][1]=0;
  
  /* nacitanie zo suboru */
  i=0;
  printf("Subor %s: ", file_name_in);
  while ((!feof(file_in))&&(i<MAX)) {
    strcmp(cislo_str, ""); 
    fscanf(file_in, "%s", cislo_str);
    cislo=atoi(cislo_str); 
    printf("%i, ", cislo);
    i=0;
    bulo=0;
    while (pocetnost[i][0]) {
      if (pocetnost[i][0]==cislo) {
        pocetnost[i][1]++;
	bulo=1;
      }
      i++;
    }
    if (!bulo) {
      pocetnost[i][0]=cislo;
      pocetnost[i][1]++;
    }
  }  

  /* zapis do suboru */
  i=0;
  printf("\nX=%i\n", kelo);
  printf("Subor %s: ", file_name_out);
  while (pocetnost[i][0]) {
    if (pocetnost[i][1]==kelo) {
      fprintf(file_out, "%i, ", pocetnost[i][0]);
      fprintf(stdout, "%i, ", pocetnost[i][0]);
    }     
    i++;
  }      

  printf("\n\nUloha splnena v poriadku\n\n");
  fclose(file_in);
  fclose(file_out);
  return(0);
}


/* funkcia vypise text ulohy */
void zadanie(char *meno_programu)
{
  printf("\nUloha 10: Int cisla zo suboru %s (max %i) ktore sa vyskytuju len X razy (X=1)", file_name_in, MAX);
  printf("\n          su zapisane do suboru %s v aktualnom adresari", file_name_out);
  printf("\n          Mena inych suborov a pocetnost X mozno zadat ako parametre");
  printf("\nPriklad : %s in out 2\n\n", meno_programu);

  return;
}
